Conteúdo
Índice 🔎︎

# Instrução GoSub...Return

Chama uma sub-rotina indicada por uma etiqueta de uma sub-rotina ou função. As instruções que se seguem à etiqueta são executadas até à próxima instrução Return. De seguida, o programa prossegue com a instrução que se segue à instrução GoSub.

## Sintaxe:

    ver Parâmetros

## Parâmetros:

Sub/Function

bloco de instruções

Etiqueta

bloco de instruções

GoSub Etiqueta

Exit Sub/Function

Etiqueta:

bloco de instruções

Return

End Sub/Function

A instrução GoSub invoca uma sub-rotina local indicada por uma etiqueta de uma sub-rotina ou função. O nome da etiqueta terá de terminar com dois pontos (":").

Se o programa encontrar uma instrução Return que não seja precedida por GoSub, o LibreOffice Basic devolve uma mensagem de erro. Utilize Exit Sub ou Exit Function para garantir que o programa abandona uma Sub ou Função antes de atingir a próxima instrução Return.

O seguinte exemplo demonstra a utilização das instruções GoSub e Return. Ao executar uma secção do programa duas vezes, o programa calcula a raiz quadrada de dois números inseridos pelo utilizador.

## Exemplo:

    Sub ExampleGoSub
    Dim iInputa As Single
    Dim iInputb As Single
    Dim iInputc As Single
        iInputa = Int(InputBox("Introduza o primeiro número: ","Entrada de número"))
        iInputb = Int(InputBox("Introduza o segundo número: ","Entrada de número"))
        iInputc=iInputa
        GoSub SquareRoot
        Print "A raiz quadrada de";iInputa;" é";iInputc
        iInputc=iInputb
        GoSub SquareRoot
        Print "A raiz quadrada de";iInputb;" é";iInputc
        Exit Sub
    SquareRoot:
        iInputc=sqr(iInputc)
        Return
    End Sub